/* errorreporter.c generated by valac 0.12.1, the Vala compiler
 * generated from errorreporter.vala, do not modify */

/* errorreporter.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Brosch Florian <flo.brosch@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdio.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>


#define VALADOC_TYPE_ERROR_REPORTER (valadoc_error_reporter_get_type ())
#define VALADOC_ERROR_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporter))
#define VALADOC_ERROR_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporterClass))
#define VALADOC_IS_ERROR_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_ERROR_REPORTER))
#define VALADOC_IS_ERROR_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_ERROR_REPORTER))
#define VALADOC_ERROR_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporterClass))

typedef struct _ValadocErrorReporter ValadocErrorReporter;
typedef struct _ValadocErrorReporterClass ValadocErrorReporterClass;
typedef struct _ValadocErrorReporterPrivate ValadocErrorReporterPrivate;

#define VALADOC_ERROR_REPORTER_TYPE_ERROR_TYPE (valadoc_error_reporter_error_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValadocErrorReporter {
	GObject parent_instance;
	ValadocErrorReporterPrivate * priv;
};

struct _ValadocErrorReporterClass {
	GObjectClass parent_class;
};

struct _ValadocErrorReporterPrivate {
	gint _warnings;
	gint _errors;
	FILE* _stream;
	ValaReport* _vreporter;
};

typedef enum  {
	VALADOC_ERROR_REPORTER_ERROR_TYPE_WARNING,
	VALADOC_ERROR_REPORTER_ERROR_TYPE_ERROR
} ValadocErrorReporterErrorType;


static gpointer valadoc_error_reporter_parent_class = NULL;

GType valadoc_error_reporter_get_type (void) G_GNUC_CONST;
#define VALADOC_ERROR_REPORTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporterPrivate))
enum  {
	VALADOC_ERROR_REPORTER_DUMMY_PROPERTY,
	VALADOC_ERROR_REPORTER_STREAM,
	VALADOC_ERROR_REPORTER_VREPORTER,
	VALADOC_ERROR_REPORTER_ERRORS,
	VALADOC_ERROR_REPORTER_WARNINGS
};
static GType valadoc_error_reporter_error_type_get_type (void) G_GNUC_UNUSED;
ValadocErrorReporter* valadoc_error_reporter_new (void);
ValadocErrorReporter* valadoc_error_reporter_construct (GType object_type);
void valadoc_error_reporter_set_stream (ValadocErrorReporter* self, FILE* value);
static inline void valadoc_error_reporter_msg (ValadocErrorReporter* self, ValadocErrorReporterErrorType type, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg);
FILE* valadoc_error_reporter_get_stream (ValadocErrorReporter* self);
void valadoc_error_reporter_simple_warning (ValadocErrorReporter* self, const gchar* msg);
void valadoc_error_reporter_simple_error (ValadocErrorReporter* self, const gchar* msg);
void valadoc_error_reporter_error (ValadocErrorReporter* self, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg);
void valadoc_error_reporter_warning (ValadocErrorReporter* self, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg);
ValaReport* valadoc_error_reporter_get_vreporter (ValadocErrorReporter* self);
void valadoc_error_reporter_set_vreporter (ValadocErrorReporter* self, ValaReport* value);
gint valadoc_error_reporter_get_errors (ValadocErrorReporter* self);
gint valadoc_error_reporter_get_warnings (ValadocErrorReporter* self);
static void valadoc_error_reporter_finalize (GObject* obj);
static void _vala_valadoc_error_reporter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valadoc_error_reporter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static GType valadoc_error_reporter_error_type_get_type (void) {
	static volatile gsize valadoc_error_reporter_error_type_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_error_reporter_error_type_type_id__volatile)) {
		static const GEnumValue values[] = {{VALADOC_ERROR_REPORTER_ERROR_TYPE_WARNING, "VALADOC_ERROR_REPORTER_ERROR_TYPE_WARNING", "warning"}, {VALADOC_ERROR_REPORTER_ERROR_TYPE_ERROR, "VALADOC_ERROR_REPORTER_ERROR_TYPE_ERROR", "error"}, {0, NULL, NULL}};
		GType valadoc_error_reporter_error_type_type_id;
		valadoc_error_reporter_error_type_type_id = g_enum_register_static ("ValadocErrorReporterErrorType", values);
		g_once_init_leave (&valadoc_error_reporter_error_type_type_id__volatile, valadoc_error_reporter_error_type_type_id);
	}
	return valadoc_error_reporter_error_type_type_id__volatile;
}


ValadocErrorReporter* valadoc_error_reporter_construct (GType object_type) {
	ValadocErrorReporter * self = NULL;
	self = (ValadocErrorReporter*) g_object_new (object_type, NULL);
	valadoc_error_reporter_set_stream (self, stderr);
	return self;
}


ValadocErrorReporter* valadoc_error_reporter_new (void) {
	return valadoc_error_reporter_construct (VALADOC_TYPE_ERROR_REPORTER);
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


static inline void valadoc_error_reporter_msg (ValadocErrorReporter* self, ValadocErrorReporterErrorType type, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (errline != NULL);
	g_return_if_fail (msg != NULL);
	if (type == VALADOC_ERROR_REPORTER_ERROR_TYPE_ERROR) {
		_tmp0_ = "error";
	} else {
		_tmp0_ = "warning";
	}
	fprintf (self->priv->_stream, "%s:%lu.%lu-%lu.%lu: %s: %s\n", file, (gulong) line, (gulong) startpos, (gulong) line, (gulong) endpos, _tmp0_, msg);
	if (startpos <= endpos) {
		fprintf (self->priv->_stream, "%s\n", errline);
		{
			gint i;
			i = 0;
			{
				gboolean _tmp1_;
				_tmp1_ = TRUE;
				while (TRUE) {
					gint _tmp2_;
					gchar _tmp3_;
					if (!_tmp1_) {
						i++;
					}
					_tmp1_ = FALSE;
					_tmp2_ = g_utf8_strlen (errline, (gssize) (-1));
					if (!(i < (_tmp2_ + 1))) {
						break;
					}
					_tmp3_ = string_get (errline, (glong) i);
					if (_tmp3_ == '\t') {
						fprintf (self->priv->_stream, "\t");
					} else {
						gboolean _tmp4_ = FALSE;
						if (i >= (startpos - 1)) {
							_tmp4_ = i < (endpos - 1);
						} else {
							_tmp4_ = FALSE;
						}
						if (_tmp4_) {
							fprintf (self->priv->_stream, "^");
						} else {
							fprintf (self->priv->_stream, " ");
						}
					}
				}
			}
		}
		fprintf (self->priv->_stream, "\n");
	}
}


void valadoc_error_reporter_simple_warning (ValadocErrorReporter* self, const gchar* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	fputs (msg, self->priv->_stream);
	fputc ('\n', self->priv->_stream);
	self->priv->_warnings++;
}


void valadoc_error_reporter_simple_error (ValadocErrorReporter* self, const gchar* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	fputs (msg, self->priv->_stream);
	fputc ('\n', self->priv->_stream);
	self->priv->_errors++;
}


void valadoc_error_reporter_error (ValadocErrorReporter* self, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (errline != NULL);
	g_return_if_fail (msg != NULL);
	valadoc_error_reporter_msg (self, VALADOC_ERROR_REPORTER_ERROR_TYPE_ERROR, file, line, startpos, endpos, errline, msg);
	self->priv->_errors++;
}


void valadoc_error_reporter_warning (ValadocErrorReporter* self, const gchar* file, glong line, glong startpos, glong endpos, const gchar* errline, const gchar* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (errline != NULL);
	g_return_if_fail (msg != NULL);
	valadoc_error_reporter_msg (self, VALADOC_ERROR_REPORTER_ERROR_TYPE_WARNING, file, line, startpos, endpos, errline, msg);
	self->priv->_warnings++;
}


FILE* valadoc_error_reporter_get_stream (ValadocErrorReporter* self) {
	FILE* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_stream;
	return result;
}


void valadoc_error_reporter_set_stream (ValadocErrorReporter* self, FILE* value) {
	g_return_if_fail (self != NULL);
	self->priv->_stream = value;
	g_object_notify ((GObject *) self, "stream");
}


ValaReport* valadoc_error_reporter_get_vreporter (ValadocErrorReporter* self) {
	ValaReport* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_vreporter;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void valadoc_error_reporter_set_vreporter (ValadocErrorReporter* self, ValaReport* value) {
	ValaReport* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_vreporter);
	self->priv->_vreporter = _tmp0_;
	g_object_notify ((GObject *) self, "vreporter");
}


gint valadoc_error_reporter_get_errors (ValadocErrorReporter* self) {
	gint result;
	gint _tmp0_ = 0;
	gint verrors;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->_vreporter != NULL) {
		gint _tmp1_;
		_tmp1_ = vala_report_get_errors (self->priv->_vreporter);
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = 0;
	}
	verrors = _tmp0_;
	result = self->priv->_errors + verrors;
	return result;
}


gint valadoc_error_reporter_get_warnings (ValadocErrorReporter* self) {
	gint result;
	gint _tmp0_ = 0;
	gint vwarnings;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->_vreporter != NULL) {
		gint _tmp1_;
		_tmp1_ = vala_report_get_warnings (self->priv->_vreporter);
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = 0;
	}
	vwarnings = _tmp0_;
	result = self->priv->_warnings + vwarnings;
	return result;
}


static void valadoc_error_reporter_class_init (ValadocErrorReporterClass * klass) {
	valadoc_error_reporter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocErrorReporterPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_error_reporter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_error_reporter_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_error_reporter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_ERROR_REPORTER_STREAM, g_param_spec_pointer ("stream", "stream", "stream", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_ERROR_REPORTER_VREPORTER, g_param_spec_object ("vreporter", "vreporter", "vreporter", VALA_TYPE_REPORT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_ERROR_REPORTER_ERRORS, g_param_spec_int ("errors", "errors", "errors", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_ERROR_REPORTER_WARNINGS, g_param_spec_int ("warnings", "warnings", "warnings", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valadoc_error_reporter_instance_init (ValadocErrorReporter * self) {
	self->priv = VALADOC_ERROR_REPORTER_GET_PRIVATE (self);
	self->priv->_warnings = 0;
	self->priv->_errors = 0;
}


static void valadoc_error_reporter_finalize (GObject* obj) {
	ValadocErrorReporter * self;
	self = VALADOC_ERROR_REPORTER (obj);
	_g_object_unref0 (self->priv->_vreporter);
	G_OBJECT_CLASS (valadoc_error_reporter_parent_class)->finalize (obj);
}


GType valadoc_error_reporter_get_type (void) {
	static volatile gsize valadoc_error_reporter_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_error_reporter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocErrorReporterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_error_reporter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocErrorReporter), 0, (GInstanceInitFunc) valadoc_error_reporter_instance_init, NULL };
		GType valadoc_error_reporter_type_id;
		valadoc_error_reporter_type_id = g_type_register_static (G_TYPE_OBJECT, "ValadocErrorReporter", &g_define_type_info, 0);
		g_once_init_leave (&valadoc_error_reporter_type_id__volatile, valadoc_error_reporter_type_id);
	}
	return valadoc_error_reporter_type_id__volatile;
}


static void _vala_valadoc_error_reporter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValadocErrorReporter * self;
	self = VALADOC_ERROR_REPORTER (object);
	switch (property_id) {
		case VALADOC_ERROR_REPORTER_STREAM:
		g_value_set_pointer (value, valadoc_error_reporter_get_stream (self));
		break;
		case VALADOC_ERROR_REPORTER_VREPORTER:
		g_value_set_object (value, valadoc_error_reporter_get_vreporter (self));
		break;
		case VALADOC_ERROR_REPORTER_ERRORS:
		g_value_set_int (value, valadoc_error_reporter_get_errors (self));
		break;
		case VALADOC_ERROR_REPORTER_WARNINGS:
		g_value_set_int (value, valadoc_error_reporter_get_warnings (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valadoc_error_reporter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValadocErrorReporter * self;
	self = VALADOC_ERROR_REPORTER (object);
	switch (property_id) {
		case VALADOC_ERROR_REPORTER_STREAM:
		valadoc_error_reporter_set_stream (self, g_value_get_pointer (value));
		break;
		case VALADOC_ERROR_REPORTER_VREPORTER:
		valadoc_error_reporter_set_vreporter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



