/* filehelper.c generated by valac 0.12.1, the Vala compiler
 * generated from filehelper.vala, do not modify */

/* filehelper.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Brosch Florian <flo.brosch@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <vala.h>

#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean valadoc_copy_file (const gchar* src, const gchar* dest);
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest);
gboolean valadoc_remove_directory (const gchar* rpath);
gchar* valadoc_realpath (const gchar* basedir);


/**
 * Makes a copy of the file src to dest. 
 *
 * @param src the file to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_file (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	FILE* _tmp0_ = NULL;
	FILE* fsrc;
	FILE* _tmp1_ = NULL;
	FILE* fdest;
	g_return_val_if_fail (src != NULL, FALSE);
	g_return_val_if_fail (dest != NULL, FALSE);
	_tmp0_ = fopen (src, "rb");
	fsrc = _tmp0_;
	if (fsrc == NULL) {
		result = FALSE;
		_fclose0 (fsrc);
		return result;
	}
	_tmp1_ = fopen (dest, "wb");
	fdest = _tmp1_;
	if (fdest == NULL) {
		result = FALSE;
		_fclose0 (fdest);
		_fclose0 (fsrc);
		return result;
	}
	{
		gint _tmp2_;
		gint c;
		_tmp2_ = fgetc (fsrc);
		c = _tmp2_;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = fgetc (fsrc);
					c = _tmp4_;
				}
				_tmp3_ = FALSE;
				_tmp5_ = feof (fsrc);
				if (!(!_tmp5_)) {
					break;
				}
				fputc ((gchar) c, fdest);
			}
		}
	}
	result = TRUE;
	_fclose0 (fdest);
	_fclose0 (fsrc);
	return result;
}


/**
 * Makes a copy of the directory src to dest. 
 *
 * @param src the directory to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* _tmp4_;
	gchar* _src;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_;
	gchar* _tmp9_;
	gchar* _dest;
	GDir* _tmp10_ = NULL;
	GDir* dir;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (src != NULL, FALSE);
	g_return_val_if_fail (dest != NULL, FALSE);
	_tmp1_ = g_str_has_suffix (src, "/");
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (src);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		gchar* _tmp3_;
		_tmp3_ = g_strconcat (src, "/", NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = g_strdup (_tmp0_);
	_src = _tmp4_;
	_tmp6_ = g_str_has_suffix (dest, "/");
	if (_tmp6_) {
		gchar* _tmp7_;
		_tmp7_ = g_strdup (dest);
		_g_free0 (_tmp5_);
		_tmp5_ = _tmp7_;
	} else {
		gchar* _tmp8_;
		_tmp8_ = g_strconcat (dest, "/", NULL);
		_g_free0 (_tmp5_);
		_tmp5_ = _tmp8_;
	}
	_tmp9_ = g_strdup (_tmp5_);
	_dest = _tmp9_;
	_tmp10_ = g_dir_open (_src, (guint) 0, &_inner_error_);
	dir = _tmp10_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			goto __catch0_g_file_error;
		}
		_g_free0 (_dest);
		_g_free0 (_tmp5_);
		_g_free0 (_src);
		_g_free0 (_tmp0_);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		const gchar* _tmp11_ = NULL;
		const gchar* name;
		_tmp11_ = g_dir_read_name (dir);
		name = _tmp11_;
		{
			gboolean _tmp12_;
			_tmp12_ = TRUE;
			while (TRUE) {
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gboolean _tmp18_;
				gboolean _tmp19_;
				if (!_tmp12_) {
					const gchar* _tmp13_ = NULL;
					_tmp13_ = g_dir_read_name (dir);
					name = _tmp13_;
				}
				_tmp12_ = FALSE;
				if (!(name != NULL)) {
					break;
				}
				_tmp14_ = g_strconcat (_src, name, NULL);
				_tmp15_ = _tmp14_;
				_tmp16_ = g_strconcat (_dest, name, NULL);
				_tmp17_ = _tmp16_;
				_tmp18_ = valadoc_copy_file (_tmp15_, _tmp17_);
				_tmp19_ = !_tmp18_;
				_g_free0 (_tmp17_);
				_g_free0 (_tmp15_);
				if (_tmp19_) {
					result = FALSE;
					_g_dir_close0 (dir);
					_g_free0 (_dest);
					_g_free0 (_tmp5_);
					_g_free0 (_src);
					_g_free0 (_tmp0_);
					return result;
				}
			}
		}
	}
	_g_dir_close0 (dir);
	goto __finally0;
	__catch0_g_file_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (err);
		_g_free0 (_dest);
		_g_free0 (_tmp5_);
		_g_free0 (_src);
		_g_free0 (_tmp0_);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_free0 (_dest);
		_g_free0 (_tmp5_);
		_g_free0 (_src);
		_g_free0 (_tmp0_);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	_g_free0 (_dest);
	_g_free0 (_tmp5_);
	_g_free0 (_src);
	_g_free0 (_tmp0_);
	return result;
}


/**
 * A recursive directory delete function
 *
 * @param rpath the directory to remove
 */
gboolean valadoc_remove_directory (const gchar* rpath) {
	gboolean result = FALSE;
	GDir* _tmp0_ = NULL;
	GDir* dir;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (rpath != NULL, FALSE);
	_tmp0_ = g_dir_open (rpath, (guint) 0, &_inner_error_);
	dir = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			goto __catch1_g_file_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	if (dir == NULL) {
		result = FALSE;
		_g_dir_close0 (dir);
		return result;
	}
	{
		const gchar* _tmp1_ = NULL;
		const gchar* entry;
		_tmp1_ = g_dir_read_name (dir);
		entry = _tmp1_;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gchar* _tmp4_;
				gchar* path;
				gboolean _tmp5_;
				gboolean is_dir;
				if (!_tmp2_) {
					const gchar* _tmp3_ = NULL;
					_tmp3_ = g_dir_read_name (dir);
					entry = _tmp3_;
				}
				_tmp2_ = FALSE;
				if (!(entry != NULL)) {
					break;
				}
				_tmp4_ = g_strconcat (rpath, entry, NULL);
				path = _tmp4_;
				_tmp5_ = g_file_test (path, G_FILE_TEST_IS_DIR);
				is_dir = _tmp5_;
				if (is_dir == TRUE) {
					gboolean _tmp6_;
					gboolean tmp;
					_tmp6_ = valadoc_remove_directory (path);
					tmp = _tmp6_;
					if (tmp == FALSE) {
						result = FALSE;
						_g_free0 (path);
						_g_dir_close0 (dir);
						return result;
					}
				} else {
					gint _tmp7_;
					gint tmp;
					_tmp7_ = g_unlink (path);
					tmp = _tmp7_;
					if (tmp > 0) {
						result = FALSE;
						_g_free0 (path);
						_g_dir_close0 (dir);
						return result;
					}
				}
				_g_free0 (path);
			}
		}
	}
	_g_dir_close0 (dir);
	goto __finally1;
	__catch1_g_file_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (err);
		return result;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


/**
 * Returns canonicalized absolute pathname
 *
 * @param basedir the path being checked
 * @return a canonicalized absolute pathname
 */
gchar* valadoc_realpath (const gchar* basedir) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (basedir != NULL, NULL);
	_tmp0_ = vala_code_context_realpath (basedir);
	result = _tmp0_;
	return result;
}



