/* markupwriter.c generated by valac 0.12.1, the Vala compiler
 * generated from markupwriter.vala, do not modify */

/* markupwriter.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch, Didier Villevalois
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define VALADOC_TYPE_MARKUP_WRITER (valadoc_markup_writer_get_type ())
#define VALADOC_MARKUP_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_MARKUP_WRITER, ValadocMarkupWriter))
#define VALADOC_MARKUP_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_MARKUP_WRITER, ValadocMarkupWriterClass))
#define VALADOC_IS_MARKUP_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_MARKUP_WRITER))
#define VALADOC_IS_MARKUP_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_MARKUP_WRITER))
#define VALADOC_MARKUP_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_MARKUP_WRITER, ValadocMarkupWriterClass))

typedef struct _ValadocMarkupWriter ValadocMarkupWriter;
typedef struct _ValadocMarkupWriterClass ValadocMarkupWriterClass;
typedef struct _ValadocMarkupWriterPrivate ValadocMarkupWriterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ValadocParamSpecMarkupWriter ValadocParamSpecMarkupWriter;

struct _ValadocMarkupWriter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValadocMarkupWriterPrivate * priv;
	FILE* stream;
	gint indent;
};

struct _ValadocMarkupWriterClass {
	GTypeClass parent_class;
	void (*finalize) (ValadocMarkupWriter *self);
	gboolean (*inline_element) (ValadocMarkupWriter* self, const gchar* name);
	gboolean (*content_inline_element) (ValadocMarkupWriter* self, const gchar* name);
};

struct _ValadocMarkupWriterPrivate {
	glong current_column;
	gboolean last_was_tag;
	gboolean wrap;
};

struct _ValadocParamSpecMarkupWriter {
	GParamSpec parent_instance;
};


static gpointer valadoc_markup_writer_parent_class = NULL;

gpointer valadoc_markup_writer_ref (gpointer instance);
void valadoc_markup_writer_unref (gpointer instance);
GParamSpec* valadoc_param_spec_markup_writer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valadoc_value_set_markup_writer (GValue* value, gpointer v_object);
void valadoc_value_take_markup_writer (GValue* value, gpointer v_object);
gpointer valadoc_value_get_markup_writer (const GValue* value);
GType valadoc_markup_writer_get_type (void) G_GNUC_CONST;
#define VALADOC_MARKUP_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_TYPE_MARKUP_WRITER, ValadocMarkupWriterPrivate))
enum  {
	VALADOC_MARKUP_WRITER_DUMMY_PROPERTY
};
#define VALADOC_MARKUP_WRITER_MAX_COLUMN 150
ValadocMarkupWriter* valadoc_markup_writer_new (FILE* stream, gboolean xml_declaration);
ValadocMarkupWriter* valadoc_markup_writer_construct (GType object_type, FILE* stream, gboolean xml_declaration);
void valadoc_markup_writer_do_write (ValadocMarkupWriter* self, const gchar* text);
ValadocMarkupWriter* valadoc_markup_writer_start_tag (ValadocMarkupWriter* self, const gchar* name, gchar** attributes, int attributes_length1);
static void valadoc_markup_writer_check_column (ValadocMarkupWriter* self, const gchar* name, gboolean end_tag);
ValadocMarkupWriter* valadoc_markup_writer_simple_tag (ValadocMarkupWriter* self, const gchar* name, gchar** attributes, int attributes_length1);
ValadocMarkupWriter* valadoc_markup_writer_end_tag (ValadocMarkupWriter* self, const gchar* name);
ValadocMarkupWriter* valadoc_markup_writer_text (ValadocMarkupWriter* self, const gchar* text);
static void valadoc_markup_writer_break_line (ValadocMarkupWriter* self);
ValadocMarkupWriter* valadoc_markup_writer_raw_text (ValadocMarkupWriter* self, const gchar* text);
void valadoc_markup_writer_set_wrap (ValadocMarkupWriter* self, gboolean wrap);
gboolean valadoc_markup_writer_inline_element (ValadocMarkupWriter* self, const gchar* name);
gboolean valadoc_markup_writer_content_inline_element (ValadocMarkupWriter* self, const gchar* name);
static gboolean valadoc_markup_writer_real_inline_element (ValadocMarkupWriter* self, const gchar* name);
static gboolean valadoc_markup_writer_real_content_inline_element (ValadocMarkupWriter* self, const gchar* name);
static void valadoc_markup_writer_finalize (ValadocMarkupWriter* obj);


/**
 * Initializes a new instance of the MarkupWriter
 * 
 * @param stream a file stream
 * @param xml_delcaration specifies whether this file starts with an xml-declaration
 */
ValadocMarkupWriter* valadoc_markup_writer_construct (GType object_type, FILE* stream, gboolean xml_declaration) {
	ValadocMarkupWriter* self = NULL;
	g_return_val_if_fail (stream != NULL, NULL);
	self = (ValadocMarkupWriter*) g_type_create_instance (object_type);
	self->stream = stream;
	if (xml_declaration) {
		valadoc_markup_writer_do_write (self, "<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	}
	self->indent = -1;
	self->priv->last_was_tag = TRUE;
	return self;
}


ValadocMarkupWriter* valadoc_markup_writer_new (FILE* stream, gboolean xml_declaration) {
	return valadoc_markup_writer_construct (VALADOC_TYPE_MARKUP_WRITER, stream, xml_declaration);
}


/**
 * Writes an start tag of a markup element to the file
 *
 * @param the name of the markup
 * @param a list of name/value pairs
 * @return this
 */
static gpointer _valadoc_markup_writer_ref0 (gpointer self) {
	return self ? valadoc_markup_writer_ref (self) : NULL;
}


ValadocMarkupWriter* valadoc_markup_writer_start_tag (ValadocMarkupWriter* self, const gchar* name, gchar** attributes, int attributes_length1) {
	ValadocMarkupWriter* result = NULL;
	GString* _tmp3_ = NULL;
	GString* content;
	ValadocMarkupWriter* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self->indent++;
	valadoc_markup_writer_check_column (self, name, FALSE);
	if ((attributes_length1 % 2) != 0) {
		gint _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = attributes_length1 + 1;
		attributes = g_renew (gchar*, attributes, attributes_length1 + 1);
		(_tmp0_ > attributes_length1) ? memset (attributes + attributes_length1, 0, sizeof (gchar*) * (_tmp0_ - attributes_length1)) : NULL;
		attributes_length1 = _tmp0_;
		_tmp1_ = g_strdup ("");
		_tmp2_ = _tmp1_;
		_g_free0 (attributes[attributes_length1 - 1]);
		attributes[attributes_length1 - 1] = _tmp2_;
	}
	_tmp3_ = g_string_new ("<");
	content = _tmp3_;
	g_string_append (content, name);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp4_;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					i = i + 2;
				}
				_tmp4_ = FALSE;
				if (!(i < attributes_length1)) {
					break;
				}
				if (attributes[i + 1] != NULL) {
					g_string_append_printf (content, " %s=\"%s\"", attributes[i], attributes[i + 1]);
				}
			}
		}
	}
	g_string_append (content, ">");
	valadoc_markup_writer_do_write (self, content->str);
	self->priv->last_was_tag = TRUE;
	_tmp5_ = _valadoc_markup_writer_ref0 (self);
	result = _tmp5_;
	_g_string_free0 (content);
	return result;
}


/**
 * Writes a simple tag (<name />) to the file
 *
 * @param the name of the markup
 * @param a list of name/value pairs
 * @return this
 */
ValadocMarkupWriter* valadoc_markup_writer_simple_tag (ValadocMarkupWriter* self, const gchar* name, gchar** attributes, int attributes_length1) {
	ValadocMarkupWriter* result = NULL;
	GString* _tmp3_ = NULL;
	GString* content;
	ValadocMarkupWriter* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self->indent++;
	valadoc_markup_writer_check_column (self, name, FALSE);
	if ((attributes_length1 % 2) != 0) {
		gint _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = attributes_length1 + 1;
		attributes = g_renew (gchar*, attributes, attributes_length1 + 1);
		(_tmp0_ > attributes_length1) ? memset (attributes + attributes_length1, 0, sizeof (gchar*) * (_tmp0_ - attributes_length1)) : NULL;
		attributes_length1 = _tmp0_;
		_tmp1_ = g_strdup ("");
		_tmp2_ = _tmp1_;
		_g_free0 (attributes[attributes_length1 - 1]);
		attributes[attributes_length1 - 1] = _tmp2_;
	}
	_tmp3_ = g_string_new ("<");
	content = _tmp3_;
	g_string_append (content, name);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp4_;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					i = i + 2;
				}
				_tmp4_ = FALSE;
				if (!(i < attributes_length1)) {
					break;
				}
				if (attributes[i + 1] != NULL) {
					g_string_append_printf (content, " %s=\"%s\"", attributes[i], attributes[i + 1]);
				}
			}
		}
	}
	g_string_append (content, "/>");
	valadoc_markup_writer_do_write (self, content->str);
	self->indent--;
	self->priv->last_was_tag = TRUE;
	_tmp5_ = _valadoc_markup_writer_ref0 (self);
	result = _tmp5_;
	_g_string_free0 (content);
	return result;
}


/**
 * Writes an end tag of a markup element to the file
 *
 * @param the name of the markup
 * @return this
 */
ValadocMarkupWriter* valadoc_markup_writer_end_tag (ValadocMarkupWriter* self, const gchar* name) {
	ValadocMarkupWriter* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	ValadocMarkupWriter* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	valadoc_markup_writer_check_column (self, name, TRUE);
	_tmp0_ = g_strdup_printf ("</%s>", name);
	_tmp1_ = _tmp0_;
	valadoc_markup_writer_do_write (self, _tmp1_);
	_g_free0 (_tmp1_);
	self->indent--;
	self->priv->last_was_tag = TRUE;
	_tmp2_ = _valadoc_markup_writer_ref0 (self);
	result = _tmp2_;
	return result;
}


/**
 * Writes the specified string to the output stream
 *
 * @see raw_text
 * @return this
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_ = NULL;
	gchar* end;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	if (end == NULL) {
		result = maxlen;
		return result;
	} else {
		result = (glong) (end - str);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= 0) {
		_tmp0_ = len >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp1_;
		_tmp1_ = string_strnlen ((gchar*) self, offset + len);
		string_length = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = strlen (self);
		string_length = (glong) _tmp2_;
	}
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}


ValadocMarkupWriter* valadoc_markup_writer_text (ValadocMarkupWriter* self, const gchar* text) {
	ValadocMarkupWriter* result = NULL;
	gboolean _tmp0_ = FALSE;
	ValadocMarkupWriter* _tmp13_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	if (self->priv->wrap) {
		gint _tmp1_;
		_tmp1_ = strlen (text);
		_tmp0_ = (_tmp1_ + self->priv->current_column) > VALADOC_MARKUP_WRITER_MAX_COLUMN;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong wrote;
		wrote = (glong) 0;
		while (TRUE) {
			gint _tmp2_;
			glong space_pos;
			gint _tmp6_;
			gint _tmp12_;
			_tmp2_ = strlen (text);
			if (!(wrote < _tmp2_)) {
				break;
			}
			space_pos = (glong) (-1);
			{
				glong i;
				i = wrote + 1;
				{
					gboolean _tmp3_;
					_tmp3_ = TRUE;
					while (TRUE) {
						gint _tmp4_;
						gchar _tmp5_;
						if (!_tmp3_) {
							i++;
						}
						_tmp3_ = FALSE;
						_tmp4_ = strlen (text);
						if (!(i < _tmp4_)) {
							break;
						}
						_tmp5_ = string_get (text, i);
						if (_tmp5_ == ' ') {
							if (((i - wrote) + self->priv->current_column) > VALADOC_MARKUP_WRITER_MAX_COLUMN) {
								break;
							}
							space_pos = i;
						}
					}
				}
			}
			_tmp6_ = strlen (text);
			if (((_tmp6_ - wrote) + self->priv->current_column) <= VALADOC_MARKUP_WRITER_MAX_COLUMN) {
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_;
				gint _tmp9_;
				_tmp7_ = string_substring (text, wrote, (glong) (-1));
				_tmp8_ = _tmp7_;
				valadoc_markup_writer_do_write (self, _tmp8_);
				_g_free0 (_tmp8_);
				_tmp9_ = strlen (text);
				wrote = (glong) (_tmp9_ + 1);
			} else {
				if (space_pos == (-1)) {
				} else {
					gchar* _tmp10_ = NULL;
					gchar* _tmp11_;
					_tmp10_ = string_substring (text, wrote, space_pos - wrote);
					_tmp11_ = _tmp10_;
					valadoc_markup_writer_do_write (self, _tmp11_);
					_g_free0 (_tmp11_);
					wrote = space_pos + 1;
				}
			}
			_tmp12_ = strlen (text);
			if (wrote < _tmp12_) {
				valadoc_markup_writer_break_line (self);
				valadoc_markup_writer_do_write (self, "  ");
			}
		}
	} else {
		valadoc_markup_writer_do_write (self, text);
	}
	self->priv->last_was_tag = FALSE;
	_tmp13_ = _valadoc_markup_writer_ref0 (self);
	result = _tmp13_;
	return result;
}


/**
 * Writes the specified string to the output stream
 *
 * @see text
 * @return this
 */
ValadocMarkupWriter* valadoc_markup_writer_raw_text (ValadocMarkupWriter* self, const gchar* text) {
	ValadocMarkupWriter* result = NULL;
	ValadocMarkupWriter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	valadoc_markup_writer_do_write (self, text);
	self->priv->last_was_tag = FALSE;
	_tmp0_ = _valadoc_markup_writer_ref0 (self);
	result = _tmp0_;
	return result;
}


void valadoc_markup_writer_set_wrap (ValadocMarkupWriter* self, gboolean wrap) {
	g_return_if_fail (self != NULL);
	self->priv->wrap = wrap;
}


static void valadoc_markup_writer_break_line (ValadocMarkupWriter* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	fprintf (self->stream, "\n");
	_tmp0_ = g_strnfill ((gsize) (self->indent * 2), ' ');
	_tmp1_ = _tmp0_;
	fprintf (self->stream, "%s", _tmp1_);
	_g_free0 (_tmp1_);
	self->priv->current_column = (glong) (self->indent * 2);
}


void valadoc_markup_writer_do_write (ValadocMarkupWriter* self, const gchar* text) {
	gboolean _tmp0_ = FALSE;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	if (self->priv->wrap) {
		gint _tmp1_;
		_tmp1_ = strlen (text);
		_tmp0_ = (self->priv->current_column + _tmp1_) > VALADOC_MARKUP_WRITER_MAX_COLUMN;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		valadoc_markup_writer_break_line (self);
	}
	fprintf (self->stream, "%s", text);
	_tmp2_ = strlen (text);
	self->priv->current_column = self->priv->current_column + ((glong) _tmp2_);
}


static void valadoc_markup_writer_check_column (ValadocMarkupWriter* self, const gchar* name, gboolean end_tag) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	if (!self->priv->wrap) {
		return;
	} else {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		if (!end_tag) {
			gboolean _tmp2_;
			_tmp2_ = valadoc_markup_writer_inline_element (self, name);
			_tmp1_ = _tmp2_;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = !self->priv->last_was_tag;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			return;
		} else {
			gboolean _tmp3_ = FALSE;
			if (end_tag) {
				gboolean _tmp4_;
				_tmp4_ = valadoc_markup_writer_content_inline_element (self, name);
				_tmp3_ = _tmp4_;
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				return;
			} else {
				gboolean _tmp5_ = FALSE;
				if (end_tag) {
					_tmp5_ = !self->priv->last_was_tag;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					return;
				}
			}
		}
	}
	valadoc_markup_writer_break_line (self);
}


static gboolean valadoc_markup_writer_real_inline_element (ValadocMarkupWriter* self, const gchar* name) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	result = FALSE;
	return result;
}


gboolean valadoc_markup_writer_inline_element (ValadocMarkupWriter* self, const gchar* name) {
	return VALADOC_MARKUP_WRITER_GET_CLASS (self)->inline_element (self, name);
}


static gboolean valadoc_markup_writer_real_content_inline_element (ValadocMarkupWriter* self, const gchar* name) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	result = TRUE;
	return result;
}


gboolean valadoc_markup_writer_content_inline_element (ValadocMarkupWriter* self, const gchar* name) {
	return VALADOC_MARKUP_WRITER_GET_CLASS (self)->content_inline_element (self, name);
}


static void valadoc_value_markup_writer_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void valadoc_value_markup_writer_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		valadoc_markup_writer_unref (value->data[0].v_pointer);
	}
}


static void valadoc_value_markup_writer_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = valadoc_markup_writer_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer valadoc_value_markup_writer_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* valadoc_value_markup_writer_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ValadocMarkupWriter* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = valadoc_markup_writer_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* valadoc_value_markup_writer_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ValadocMarkupWriter** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = valadoc_markup_writer_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* valadoc_param_spec_markup_writer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ValadocParamSpecMarkupWriter* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VALADOC_TYPE_MARKUP_WRITER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer valadoc_value_get_markup_writer (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALADOC_TYPE_MARKUP_WRITER), NULL);
	return value->data[0].v_pointer;
}


void valadoc_value_set_markup_writer (GValue* value, gpointer v_object) {
	ValadocMarkupWriter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALADOC_TYPE_MARKUP_WRITER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALADOC_TYPE_MARKUP_WRITER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		valadoc_markup_writer_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		valadoc_markup_writer_unref (old);
	}
}


void valadoc_value_take_markup_writer (GValue* value, gpointer v_object) {
	ValadocMarkupWriter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALADOC_TYPE_MARKUP_WRITER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALADOC_TYPE_MARKUP_WRITER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		valadoc_markup_writer_unref (old);
	}
}


static void valadoc_markup_writer_class_init (ValadocMarkupWriterClass * klass) {
	valadoc_markup_writer_parent_class = g_type_class_peek_parent (klass);
	VALADOC_MARKUP_WRITER_CLASS (klass)->finalize = valadoc_markup_writer_finalize;
	g_type_class_add_private (klass, sizeof (ValadocMarkupWriterPrivate));
	VALADOC_MARKUP_WRITER_CLASS (klass)->inline_element = valadoc_markup_writer_real_inline_element;
	VALADOC_MARKUP_WRITER_CLASS (klass)->content_inline_element = valadoc_markup_writer_real_content_inline_element;
}


static void valadoc_markup_writer_instance_init (ValadocMarkupWriter * self) {
	self->priv = VALADOC_MARKUP_WRITER_GET_PRIVATE (self);
	self->priv->current_column = (glong) 0;
	self->priv->wrap = TRUE;
	self->ref_count = 1;
}


static void valadoc_markup_writer_finalize (ValadocMarkupWriter* obj) {
	ValadocMarkupWriter * self;
	self = VALADOC_MARKUP_WRITER (obj);
}


/**
 * Writes markups and text to a file.
 */
GType valadoc_markup_writer_get_type (void) {
	static volatile gsize valadoc_markup_writer_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_markup_writer_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { valadoc_value_markup_writer_init, valadoc_value_markup_writer_free_value, valadoc_value_markup_writer_copy_value, valadoc_value_markup_writer_peek_pointer, "p", valadoc_value_markup_writer_collect_value, "p", valadoc_value_markup_writer_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ValadocMarkupWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_markup_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocMarkupWriter), 0, (GInstanceInitFunc) valadoc_markup_writer_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType valadoc_markup_writer_type_id;
		valadoc_markup_writer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValadocMarkupWriter", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&valadoc_markup_writer_type_id__volatile, valadoc_markup_writer_type_id);
	}
	return valadoc_markup_writer_type_id__volatile;
}


gpointer valadoc_markup_writer_ref (gpointer instance) {
	ValadocMarkupWriter* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void valadoc_markup_writer_unref (gpointer instance) {
	ValadocMarkupWriter* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VALADOC_MARKUP_WRITER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



