/* token.c generated by valac 0.12.1, the Vala compiler
 * generated from token.vala, do not modify */

/* token.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch, Didier Villevalois
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define VALADOC_TYPE_TOKEN (valadoc_token_get_type ())
#define VALADOC_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_TOKEN, ValadocToken))
#define VALADOC_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_TOKEN, ValadocTokenClass))
#define VALADOC_IS_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_TOKEN))
#define VALADOC_IS_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_TOKEN))
#define VALADOC_TOKEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_TOKEN, ValadocTokenClass))

typedef struct _ValadocToken ValadocToken;
typedef struct _ValadocTokenClass ValadocTokenClass;
typedef struct _ValadocTokenPrivate ValadocTokenPrivate;

#define VALADOC_TYPE_TOKEN_TYPE (valadoc_token_type_get_type ())
#define VALADOC_TOKEN_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_TOKEN_TYPE, ValadocTokenType))
#define VALADOC_TOKEN_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_TOKEN_TYPE, ValadocTokenTypeClass))
#define VALADOC_IS_TOKEN_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_TOKEN_TYPE))
#define VALADOC_IS_TOKEN_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_TOKEN_TYPE))
#define VALADOC_TOKEN_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_TOKEN_TYPE, ValadocTokenTypeClass))

typedef struct _ValadocTokenType ValadocTokenType;
typedef struct _ValadocTokenTypeClass ValadocTokenTypeClass;

#define VALADOC_TYPE_SOURCE_LOCATION (valadoc_source_location_get_type ())
typedef struct _ValadocSourceLocation ValadocSourceLocation;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValadocToken {
	GObject parent_instance;
	ValadocTokenPrivate * priv;
};

struct _ValadocTokenClass {
	GObjectClass parent_class;
};

struct _ValadocSourceLocation {
	gint line;
	gint column;
};

struct _ValadocTokenPrivate {
	ValadocTokenType* _type;
	gchar* _word;
	ValadocSourceLocation _begin;
	ValadocSourceLocation _end;
};


static gpointer valadoc_token_parent_class = NULL;

GType valadoc_token_get_type (void) G_GNUC_CONST;
GType valadoc_token_type_get_type (void) G_GNUC_CONST;
GType valadoc_source_location_get_type (void) G_GNUC_CONST;
ValadocSourceLocation* valadoc_source_location_dup (const ValadocSourceLocation* self);
void valadoc_source_location_free (ValadocSourceLocation* self);
#define VALADOC_TOKEN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_TYPE_TOKEN, ValadocTokenPrivate))
enum  {
	VALADOC_TOKEN_DUMMY_PROPERTY,
	VALADOC_TOKEN_IS_WORD,
	VALADOC_TOKEN_IS_NUMBER,
	VALADOC_TOKEN_WORD,
	VALADOC_TOKEN_TOKEN_TYPE,
	VALADOC_TOKEN_BEGIN,
	VALADOC_TOKEN_END
};
ValadocToken* valadoc_token_new_from_type (ValadocTokenType* type, ValadocSourceLocation* begin, ValadocSourceLocation* end);
ValadocToken* valadoc_token_construct_from_type (GType object_type, ValadocTokenType* type, ValadocSourceLocation* begin, ValadocSourceLocation* end);
ValadocToken* valadoc_token_new_from_word (const gchar* word, ValadocSourceLocation* begin, ValadocSourceLocation* end);
ValadocToken* valadoc_token_construct_from_word (GType object_type, const gchar* word, ValadocSourceLocation* begin, ValadocSourceLocation* end);
gchar* valadoc_token_to_string (ValadocToken* self);
gchar* valadoc_token_type_to_string (ValadocTokenType* self);
gchar* valadoc_token_to_pretty_string (ValadocToken* self);
gchar* valadoc_token_type_to_pretty_string (ValadocTokenType* self);
gint valadoc_token_to_int (ValadocToken* self);
gboolean valadoc_token_get_is_number (ValadocToken* self);
ValadocToken* valadoc_token_new (void);
ValadocToken* valadoc_token_construct (GType object_type);
gboolean valadoc_token_get_is_word (ValadocToken* self);
const gchar* valadoc_token_get_word (ValadocToken* self);
ValadocTokenType* valadoc_token_get_token_type (ValadocToken* self);
void valadoc_token_get_begin (ValadocToken* self, ValadocSourceLocation* result);
void valadoc_token_get_end (ValadocToken* self, ValadocSourceLocation* result);
static void valadoc_token_finalize (GObject* obj);
static void _vala_valadoc_token_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ValadocToken* valadoc_token_construct_from_type (GType object_type, ValadocTokenType* type, ValadocSourceLocation* begin, ValadocSourceLocation* end) {
	ValadocToken * self = NULL;
	ValadocTokenType* _tmp0_;
	g_return_val_if_fail (type != NULL, NULL);
	self = (ValadocToken*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (type);
	_g_object_unref0 (self->priv->_type);
	self->priv->_type = _tmp0_;
	self->priv->_begin = *begin;
	self->priv->_end = *end;
	return self;
}


ValadocToken* valadoc_token_new_from_type (ValadocTokenType* type, ValadocSourceLocation* begin, ValadocSourceLocation* end) {
	return valadoc_token_construct_from_type (VALADOC_TYPE_TOKEN, type, begin, end);
}


ValadocToken* valadoc_token_construct_from_word (GType object_type, const gchar* word, ValadocSourceLocation* begin, ValadocSourceLocation* end) {
	ValadocToken * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (word != NULL, NULL);
	self = (ValadocToken*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (word);
	_g_free0 (self->priv->_word);
	self->priv->_word = _tmp0_;
	self->priv->_begin = *begin;
	self->priv->_end = *end;
	return self;
}


ValadocToken* valadoc_token_new_from_word (const gchar* word, ValadocSourceLocation* begin, ValadocSourceLocation* end) {
	return valadoc_token_construct_from_word (VALADOC_TYPE_TOKEN, word, begin, end);
}


gchar* valadoc_token_to_string (ValadocToken* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->_word == NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = valadoc_token_type_to_string (self->priv->_type);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self->priv->_word);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


gchar* valadoc_token_to_pretty_string (ValadocToken* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->_word == NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = valadoc_token_type_to_pretty_string (self->priv->_type);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self->priv->_word);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


gint valadoc_token_to_int (ValadocToken* self) {
	gint result = 0;
	gboolean _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = valadoc_token_get_is_number (self);
	g_assert (_tmp0_);
	_tmp1_ = atoi (self->priv->_word);
	result = _tmp1_;
	return result;
}


ValadocToken* valadoc_token_construct (GType object_type) {
	ValadocToken * self = NULL;
	self = (ValadocToken*) g_object_new (object_type, NULL);
	return self;
}


ValadocToken* valadoc_token_new (void) {
	return valadoc_token_construct (VALADOC_TYPE_TOKEN);
}


gboolean valadoc_token_get_is_word (ValadocToken* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_word != NULL;
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


gboolean valadoc_token_get_is_number (ValadocToken* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->_word == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = strlen (self->priv->_word);
		_tmp0_ = _tmp1_ == 0;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	} else {
		gboolean _tmp2_ = FALSE;
		gchar _tmp3_;
		_tmp3_ = string_get (self->priv->_word, (glong) 0);
		if (_tmp3_ == '0') {
			gint _tmp4_;
			_tmp4_ = strlen (self->priv->_word);
			_tmp2_ = _tmp4_ > 1;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			result = FALSE;
			return result;
		}
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				gboolean _tmp7_ = FALSE;
				gchar _tmp8_;
				if (!_tmp5_) {
					i++;
				}
				_tmp5_ = FALSE;
				_tmp6_ = strlen (self->priv->_word);
				if (!(i < _tmp6_)) {
					break;
				}
				_tmp8_ = string_get (self->priv->_word, (glong) i);
				if (_tmp8_ < '0') {
					_tmp7_ = TRUE;
				} else {
					gchar _tmp9_;
					_tmp9_ = string_get (self->priv->_word, (glong) i);
					_tmp7_ = _tmp9_ > '9';
				}
				if (_tmp7_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


const gchar* valadoc_token_get_word (ValadocToken* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_word;
	return result;
}


ValadocTokenType* valadoc_token_get_token_type (ValadocToken* self) {
	ValadocTokenType* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_type;
	return result;
}


void valadoc_token_get_begin (ValadocToken* self, ValadocSourceLocation* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_begin;
	return;
}


void valadoc_token_get_end (ValadocToken* self, ValadocSourceLocation* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_end;
	return;
}


static void valadoc_token_class_init (ValadocTokenClass * klass) {
	valadoc_token_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocTokenPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_token_get_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_token_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_IS_WORD, g_param_spec_boolean ("is-word", "is-word", "is-word", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_IS_NUMBER, g_param_spec_boolean ("is-number", "is-number", "is-number", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_WORD, g_param_spec_string ("word", "word", "word", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_TOKEN_TYPE, g_param_spec_object ("token-type", "token-type", "token-type", VALADOC_TYPE_TOKEN_TYPE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_BEGIN, g_param_spec_boxed ("begin", "begin", "begin", VALADOC_TYPE_SOURCE_LOCATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_TOKEN_END, g_param_spec_boxed ("end", "end", "end", VALADOC_TYPE_SOURCE_LOCATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valadoc_token_instance_init (ValadocToken * self) {
	self->priv = VALADOC_TOKEN_GET_PRIVATE (self);
	self->priv->_type = NULL;
	self->priv->_word = NULL;
}


static void valadoc_token_finalize (GObject* obj) {
	ValadocToken * self;
	self = VALADOC_TOKEN (obj);
	_g_object_unref0 (self->priv->_type);
	_g_free0 (self->priv->_word);
	G_OBJECT_CLASS (valadoc_token_parent_class)->finalize (obj);
}


GType valadoc_token_get_type (void) {
	static volatile gsize valadoc_token_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_token_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocTokenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_token_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocToken), 0, (GInstanceInitFunc) valadoc_token_instance_init, NULL };
		GType valadoc_token_type_id;
		valadoc_token_type_id = g_type_register_static (G_TYPE_OBJECT, "ValadocToken", &g_define_type_info, 0);
		g_once_init_leave (&valadoc_token_type_id__volatile, valadoc_token_type_id);
	}
	return valadoc_token_type_id__volatile;
}


static void _vala_valadoc_token_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValadocToken * self;
	ValadocSourceLocation boxed0;
	ValadocSourceLocation boxed1;
	self = VALADOC_TOKEN (object);
	switch (property_id) {
		case VALADOC_TOKEN_IS_WORD:
		g_value_set_boolean (value, valadoc_token_get_is_word (self));
		break;
		case VALADOC_TOKEN_IS_NUMBER:
		g_value_set_boolean (value, valadoc_token_get_is_number (self));
		break;
		case VALADOC_TOKEN_WORD:
		g_value_set_string (value, valadoc_token_get_word (self));
		break;
		case VALADOC_TOKEN_TOKEN_TYPE:
		g_value_set_object (value, valadoc_token_get_token_type (self));
		break;
		case VALADOC_TOKEN_BEGIN:
		valadoc_token_get_begin (self, &boxed0);
		g_value_set_boxed (value, &boxed0);
		break;
		case VALADOC_TOKEN_END:
		valadoc_token_get_end (self, &boxed1);
		g_value_set_boxed (value, &boxed1);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



